--The main creation function

function CreateFrames()
--Create the main window and set it to watch for key events
	IndiWindow = NewWindow{x=WardenData.x,y=WardenData.y,width=6*IconSize,height=20,colour=Turbine.UI.Color( 0.1, 0, 0,0)}
	IndiWindow:SetMouseVisible(false)
	IndiWindow.DragBar = Deusdictum.UI.DragBar( IndiWindow, "Gambit Indicator")
	IndiWindow.DragBar:SetBarOnTop( not(WardenData.reverse) ) --Bar underneath?
	IndiWindow:SetVisible (false)
	
	IndiWindow.DragEnable =function(Sender,Args)  
		IndiWindow:SetMouseVisible(true) 
		IndiWindow:SetVisible(true)
		IndiWindow.DragBar:Refresh()
		IndiWindow.DragBar:SetZOrder(9999)
	end
	IndiWindow.DragDisable =function(Sender,Args) 
		IndiWindow:SetMouseVisible(false) 
		if not (Player:IsInCombat()) then
			IndiWindow:SetVisible (WardenData.showOOC)
		end
	end
	IndiWindow.DragEnd=function() 
		WardenData.x,WardenData.y=IndiWindow:GetPosition() 
		if WardenData.reverse then 
			WardenData.y=IndiWindow:GetBottom() 
		end 
		Display() 
		IndiWindow.DragBar:Refresh() 
	end
	
	IndiWindow.MouseDown=function(sender,args)
		if IndiWindow.DragBar:IsVisible() then
			moving=true
		end	
	end
	
	IndiWindow.MouseUp=function(sender,args)
		moving=false
	end
	
	IndiWindow.MouseMove=function(sender,args)
			if moving then
			local x,y=IndiWindow:GetMousePosition()

			IconSize=x/6
			if IconSize<16 then IconSize=16 end

			Display()
			IndiWindow:SetWidth(IconSize*6)
			IndiWindow.DragBar:Refresh()
		end
	end	
	
	--Gambit changed event.	
	PlayerAttributes.GambitChanged=function(sender,args)  
		if PlayerAttributes:GetGambitCount() >0 then
			local key=PlayerAttributes:GetGambit(PlayerAttributes:GetGambitCount())
			Update(key)
		else
			Update(4)
		end
	end
		
--Create Box for Gambits
	Main=NewListbox(1024,1)
	Main:SetParent(IndiWindow)
		
--Create the Tooltip Window
	Tooltip={}
	Tooltip.Window=NewWindow{x=0,y=0,width=192,height=60,colour=Turbine.UI.Color( 0.5, 0, 0,0)}
	Tooltip.Window:SetVisible(false)
	Tooltip.Window:SetZOrder(99)
	
--Create an Overflow message for if the box gets too big...
	overflowlabel=label("Overflow! Too many!",192,Turbine.UI.Color( 0.5, 1, 0,0))
	overflowlabel:SetParent(IndiWindow)
	overflowlabel:SetVisible(false)
		
--If the player wants the frame showing OOC then display it!
	IndiWindow:SetVisible (WardenData.showOOC)
	Display()
	--Watch for the player leaving combat and re-set the frame when that happens. When entering combat display the frame.
	-- add a callback
	handle = AddCallback(Player, "InCombatChanged", function(sender, args )
		--Turbine.Shell.WriteLine("WI: In combat changed")
		if not (Player:IsInCombat()) then
			IndiWindow:SetVisible (WardenData.showOOC)
			ResetGambits()
			Display()
		else
			IndiWindow:SetVisible (true)
			Display()
		end
	end)
end

function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

--Update function called when a gambit key is pressed.

		function Update(n)

		--Gambit key pressed. Clear the display and reset the variables
			if n==4  then
				if not (Player:IsInCombat()) then
					IndiWindow:SetVisible (WardenData.showOOC)
				end
				ResetGambits()
				Display()
				return
			end		

			IndiWindow:SetVisible (true)

		--Scan the Gambit List and remove non-compatible gambits.
		for i,k in pairs(GambitList) do
			for j=1, #k do
				if k[j]~=nil then
						if string.sub (k[j],1,1)==tostring(n) then --If first letter matches then...
							--...trim the rest.
							k[j]=string.sub (k[j],2)
						else
							--Otherwise delete the gambit from the list
							if not(WardenData.fix) then
								--If gambits are "free" then just delete
								k[j]=""
							else
								--However, if positions are fixed then change to just the gambit icon preceded by a space
								if (n==1 or n==2 or n==3) then  k[j]=" "..string.sub (k[j], string.len(k[j]),string.len(k[j])) end
							end
						end
				end
			end
		end

		Display()
		end
		
--Displays the Indicator window by loading the lists into the boxes.
	function Display()
		--Clear the main listbox then add the sub list-boxes. This loop is needed otherwise the box does not clear correctly.
		for i=1,Main:GetItemCount() do
			Main:GetItem(i):SetVisible(false)
		end
		Main:ClearItems() --Nasty hack gone now!

		GambitBox	(HOT,			"Heal Over Time",		GambitList.HOTs)	
		GambitBox	(AVOID,		"Avoidance",				GambitList.Avoids)
		GambitBox	(DPS,			"DPS",							GambitList.DOTs)
		GambitBox	(MDRAIN,	"Morale Drain",			GambitList.MDs)
		GambitBox	(TOT,			"Threat Over Time",	GambitList.TOTs)
		GambitBox	(TT,				"Threat Transfer",		GambitList.TTs)
		GambitBox	(TI,				"Threat",						GambitList.TIs)
		
		local height=0
		
		for i=1,Main:GetItemCount() do
			height=height+Main:GetItem(i):GetHeight()
		end
				
		if height==0 then height=WardenData.maxheight/2 end -- sort of a minimum height. Stops a bug caused by the Dragbar.
		--If the frame is bigger than the maximum height then add a warning at the bottom of the box.
			if height>WardenData.maxheight then
				--remove boxes till the data fits
				local i=Main:GetItemCount()
				repeat
					height=height-Main:GetItem(i):GetHeight()
					Main:RemoveItemAt(i)
					i=i-1
				until height<WardenData.maxheight-16 or i<1
				height=height+16
				overflowlabel:SetPosition(0,height-16)
				overflowlabel:SetVisible(true)
			else
		--Hide the overflow label
				overflowlabel:SetVisible(false)
			end
		IndiWindow:SetHeight(height) -- Resize the window - may end up being bigger than the screen!
		Main:SetHeight(height) -- Also Resize the main listbox
		if WardenData.reverse then 
			IndiWindow:SetPosition(WardenData.x,WardenData.y-height) 
		else 
			IndiWindow:SetPosition(WardenData.x,WardenData.y) 
		end
	end

--Simple label function
		label=class(Turbine.UI.Label)
		function label:Constructor (text,width,colour)
			if width==nil then width=6*IconSize end
			if colour==nil then colour=Turbine.UI.Color( 0.1,0,0,0 ) end
			Turbine.UI.Label.Constructor(self)
			
			self:SetBackColor( colour );
			if IconSize>24 then self:SetSize( width, 20 ); self:SetFont(Turbine.UI.Lotro.Font.TrajanPro16) else self:SetSize( width, 15 ); self:SetFont(Turbine.UI.Lotro.Font.TrajanPro13) end
			self:SetText( text );
			self:SetMouseVisible (false)
		end

--Simple Listbox function.
		NewListbox= class(Turbine.UI.ListBox)
		function NewListbox:Constructor (height,n)
			Turbine.UI.ListBox.Constructor(self)
			self:SetSize( 6*IconSize, height);
			self:SetMaxItemsPerLine(n)
			self:SetOrientation( Turbine.UI.Orientation.Horizontal);
			self:SetMouseVisible (false)
		end

--Linebreak function; Those pesky columns in Listboxes! Moves to the next line by adding n blank labels.
		function linebreak (target,n,size)
		size=size or IconSize
			for i=1, n do
				target:AddItem(label("",size))
			end
		end

--Icon function; Create an icon from one of the four categories.
		Icon = class( Turbine.UI.Control )		  
		function Icon:Constructor(i)
			local IconStyle
			local index
			Turbine.UI.Control.Constructor( self );
			self :SetSize ( IconSize,IconSize)
			self:SetMouseVisible (false)
			if i~="1" and i~="2" and i~="3" and i~="5" then
				self:SetMouseVisible (true)
				index=string.byte (i)-53
				IconStyle=(ResourceDir.."32".."/sk_warden_"..Data[index][5]) -- If the plugin breaks here I have a name wrong!
				
				--Tooltip events
				self.MouseEnter = function(sender,args)
						Tooltip.Cata=nil
						Tooltip.stats=nil
						Tooltip.Cata=label(Data[index][4],192,Turbine.UI.Color( 0.5, 0, 0,0))
							Tooltip.stats=Turbine.UI.Label()
							Tooltip.stats:SetText(Data[index][6])
							Tooltip.stats:SetWidth(192)
							Tooltip.stats:SetBackColor(Turbine.UI.Color( 0.5, 0, 0,0))
							Tooltip.stats:SetFont(Turbine.UI.Lotro.Font.Verdana10)
							Tooltip.stats:SetHeight(40)
						
						Tooltip.Cata:SetParent(Tooltip.Window)
						Tooltip.stats:SetParent(Tooltip.Window)
						
						Tooltip.Cata:SetPosition(0,0)
						Tooltip.stats:SetPosition(0,20)

						Tooltip.Window:SetVisible(true)
					local x,y=Turbine.UI.Display.GetMousePosition()
					local w,h=Turbine.UI.Display.GetSize()
						if x+192>w then x=w-192 end
						if y+60>h then y=h-60 end
						Tooltip.Window:SetPosition(x,y-60)

				end
				
				self.MouseLeave = function(sender,args)
					Tooltip.Window:SetVisible(false)
				end

			else
				IconStyle=ResourceDir.."32".."/"..icons[tonumber (i)]
				--Turbine.Shell.WriteLine(IconStyle)
			end
			self.Image=Turbine.UI.Control()
			self.Image:SetParent(self)
			self.Image:SetSize(32,32)
			self.Image:SetBackground (IconStyle)
			self.Image:SetStretchMode(1)
			self.Image:SetSize( IconSize,IconSize)
		end
		
--Indicators of different purposes of gambit
	IndiIcon = class( Turbine.UI.Control )		  
	function IndiIcon:Constructor(i)
		--i contains the code for HoT=true,	ToT=false,	Threat=false,	TT=false,	BEP=false,	Targets=n
		Turbine.UI.Control.Constructor( self )
		local scale=IconSize/32
		self:SetSize(32*scale,32*scale)
		
		local function block(self,name,a,b,c,x,y)
			name=Turbine.UI.Control()
			name:SetParent(self)
			name:SetSize(8*scale,8*scale)
			name:SetBackColor(Turbine.UI.Color(1,a,b,c))
			name:SetPosition(x*scale,y*scale)
		end
		--																			R			G			B					X		Y
		if i.Threat then 				block(self,	self.A,		1,			0,			0,					8,		2) end
		if i.ToT then 					block(self,	self.B,		1,			0.44, 	0.17,			8,		12) end
		if i.TT then 						block(self,	self.C,		1,			1,			0,					8,		22) end
		if i.HoT then 					block(self,	self.D,		0,			1,			0,					24,	2) end
		if i.BEP then 					block(self,	self.E,		0,			0,			1,					24,	12) end
		if i.Targets~=false then 	block(self,	self.F,		1,			1,			1,					24,	22) end

	end
	
--Return a shortcut, instead of an icon
Shortcut=class(Turbine.UI.Control)
	function Shortcut:Constructor(i)
	if tonumber(i)==nil or tonumber(i)>3 then i="4" end
	Turbine.UI.Control.Constructor( self )
		self :SetSize ( IconSize,IconSize)

		self.Shortcut=Turbine.UI.Lotro.Quickslot()
		self.Shortcut:SetParent(self)
		self.Shortcut:SetSize(36,36)
		local adjust=IconSize/10
		self.Shortcut:SetPosition(-adjust,-adjust)
		self.Shortcut:SetShortcut(Turbine.UI.Lotro.Shortcut( SkillCodes[tonumber(i)].Type,SkillCodes[tonumber(i)].Data ))
		self.Shortcut:SetStretchMode(1)
		self.Shortcut:SetSize( IconSize+adjust,IconSize+adjust)
	end
		
	SkillCodes = 
				{
				[1.000000] = 
				{
					["Data"] = "0x7000E867",
					["Type"] = 6.000000
				},
				[2.000000] = 
				{
					["Data"] = "0x7000ED0E",
					["Type"] = 6.000000
				},
				[3.000000] = 
				{
					["Data"] = "0x7000EECF",
					["Type"] = 6.000000
				},
				[4.000000] = 
				{
					["Data"] = "0x70015F56",
					["Type"] = 6.000000
				}}	
		
		
	
--Gambit; Takes a list of skills and a target listbox and sends a Gambit there, before linebreaking to the next line of the listbox.
		function Gambit(target,SkillList)
			if SkillList~="" then
				local index=string.byte (string.sub (SkillList, string.len(SkillList),string.len(SkillList)))-53 --This gets the position of the gambit in the overall list.
				if WardenData.showgambit[index] then --If the gambit is to be shown then show it!
					if string.sub (SkillList, 1,1)~=" " then --The space is used when the "fix" feature has been selected
						--Indi is a hidden setting for now.
						if indi then target:AddItem(IndiIcon({HoT=Data[index].HoT,	ToT=Data[index].ToT,	Threat=Data[index].Threat,	TT=Data[index].TT,	BEP=Data[index].BEP,	Targets=Data[index].Targets})) end
						for i=1, #SkillList do
							local thisskill=string.sub (SkillList, i,i)
							--Change now - the second slot is actually a shortcut to a skill.
							if i==1 and WardenData.click then
									target:AddItem(Shortcut(thisskill))
							else
								target:AddItem(Icon(thisskill))
							end
						end
						if indi then linebreak(target,5-#SkillList) else linebreak(target,6-#SkillList) end
					else
						--Fix feature
						target:AddItem(Icon("5"))
						linebreak(target,5)
					end
				else
					return false 
				end
			end
			return true
		end

--AddGambits; Given a target listbox, and a list of gambits, adds them to the listbox!
		function AddGambits (target,List)
			for i=1,#List do
				local test=Gambit(target,List[i])
				if not(test) then h=h-1 end
			end
		end

--Gambit box; Creates a new listbox, named "Target" with label "name" and loads it with the gambits in "List". Calls the functions above.
		function GambitBox(target,name,list)
			h=countlist(list)
			if h~=0 then
				local title=label(name)
				if target==nil then target= NewListbox(IconSize,6) else target:ClearItems() end
				AddGambits(target,list)
				target:SetHeight(h*IconSize)
				if h>0 then
					Main:AddItem(title)
					Main:AddItem(target)
				end
			end
		end

--countlist; Counts the number of non-empty items in a list. Used to decide the height of the listboxes.
		function countlist(n)
		g=0
		for i=1, #n do
			--if n[i]~=nil then
				if n[i]~="" or WardenData.fix then --If it's empty don't count it BUT do count it if fixed position is required.
					g=g+1
				end
			--end
		end
		return g
		end

		--[[**DeepCopy
		Copies a table - completely and in a "Deep" way.
		And LITERALLY - objects and all.
		I do not pretend to understand the code of this.

		From http://lua-users.org/wiki/CopyTable]]
		function deepcopy(object)
			local lookup_table = {}
			local function _copy(object)
				if type(object) ~= "table" then
					return object
				elseif lookup_table[object] then
					return lookup_table[object]
				end
				local new_table = {}
				lookup_table[object] = new_table
				for index, value in pairs(object) do
						new_table[_copy(index)] = _copy(value)
				end
				return setmetatable(new_table, getmetatable(object))
			end
			return _copy(object)
		end

--Window creator
NewWindow = class( Turbine.UI.Window )
	function NewWindow:Constructor(options)
		Turbine.UI.Window.Constructor( self )
		self :SetPosition			( options.x,options.y)
		self :SetSize				( options.width,options.height )
		self :SetVisible			( options.visible or 1 )
		self :SetOpacity			( options.opacity or 1 )
		if options.mousevisible ~=nil then self :SetMouseVisible	( options.mousevisible) end
		if options.image ~=nil then 	self :SetBackground ( options.image) else self :SetBackColor ( options.colour or Turbine.UI.Color( 1, 0, 0)) end
	end
	
	function NewWindow:GetRight()
		return self:GetLeft()+self:GetWidth()
	end
	
	function NewWindow:GetBottom()
		return self:GetTop()+self:GetHeight()
	end
		
