import "Turbine"
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "JackdawPlugins.WardenIndicator.Function"
import "JackdawPlugins.WardenIndicator.Data"
import "JackdawPlugins.WardenIndicator.Options"

import "Deusdictum.UI.Dragbar" -- I *love* this plugin!

--Load the save game patch, if available.
if not pcall(function() import "JackdawPlugins.Patch.Patch" end) then 
	--Turbine.Shell.WriteLine("Patch not present - default Load and Save used")
	JackdawPlugins.Patch={}
	function JackdawPlugins.Patch.Load(a,b,c) return Turbine.PluginData.Load(a,b,c) end
	function JackdawPlugins.Patch.Save(a,b,c,d) Turbine.PluginData.Save(a,b,c,d) end
end

Player = Turbine.Gameplay.LocalPlayer.GetInstance()
PlayerAttributes=Player:GetClassAttributes()

indi=false --Little graphical indicator of the stats of the gambit. Hidden extra for now.

--Concept; After pressing the initial gambit key, an indicator pops up with suggestions under each major category of gambit skill.

--Many thanks to DeusDictum and the author of http://lorebook.lotro.com/wiki/Warden:_Gambits_Sorted_By_Effect where the tables come from!

--[[Unavoidable Issues; 
		Shows Gambits I do not know, but am the right level for.

	NOTE:
		We have a window, with a listbox. This listbox contains the labels and then sub-listboxes to hold the gambits. The reason there is not just one big listbox is that otherwise the text width messes up.
	]]--

--Load data
WardenData=JackdawPlugins.Patch.Load( Turbine.DataScope.Character, "WardenIndicator" );
if WardenData==nil then
	WardenData={x=200,y=200,minsize=1,reverse=true,IconSize=32,showOOC=true,maxheight=800,fix=true,click=false}
	Turbine.Shell.WriteLine("Welcome to Warden Indicator, Sir! Type /WI for options, Sir!")
end

--If the table for which gambits to show does not exist, then set it to the defaults - all shown.
if WardenData.showgambit==nil then defaultshow() end
if WardenData.maxheight==nil then WardenData.maxheight=800 end

height=WardenData.maxheight/2 --Default Height is half of the maximum height - seems sensible.

IconSize=WardenData.IconSize

--Reset the gambit table.
LoadRawList()
ResetGambits()

--Create all the frames and lets go!
CreateFrames()

--Register to save on Unload.

Plugins["WardenIndicator"].Unload = function( sender, args )
	WardenData.x,WardenData.y=IndiWindow:GetPosition()
	WardenData.IconSize=IconSize
	if WardenData.reverse then WardenData.y=IndiWindow:GetBottom() end
	Turbine.PluginData.Save( Turbine.DataScope.Character, "WardenIndicator", WardenData )
end